/*
 * Angular 2 decorators and services
 */
import {
  Component,
  OnInit,
  ViewEncapsulation
} from '@angular/core';
import { AppState } from './app.service';

/*
 * App Component
 * Top Level Component
 */
@Component({
  selector: 'app',
  encapsulation: ViewEncapsulation.None,
  // styles and styleUrls both(same) will inject style tag in head for component view is general i.e encapsulation: ViewEncapsulation.None
  // styleUrls not working for absoluate url - for node_modules
  // require('bootstrap/dist/css/bootstrap.css') can help to include bootstrap at root Level
  // .eof font issue will be there for loaders
  // one can include indiviual cmp level css/less like alert.less from bootstrap less folder
  // styleUrls: [
  //   './app.component.css'    
  // ],
  styles: [
    require('./app.component.css')    
  ],
  templateUrl: './app.component.html'
})
export class AppComponent implements OnInit {
  public angularclassLogo = 'assets/img/angularclass-avatar.png';
  public name = 'Angular 2 Webpack Starter';
  public url = 'https://twitter.com/AngularClass';

  constructor(
    public appState: AppState
  ) {}

  public ngOnInit() {
    console.log('Initial App State', this.appState.state);
  }

}

/*
 * Please review the https://github.com/AngularClass/angular2-examples/ repo for
 * more angular app examples that you may copy/paste
 * (The examples may not be updated as quickly. Please open an issue on github for us to update it)
 * For help or questions please contact us at @AngularClass on twitter
 * or our chat on Slack at https://AngularClass.com/slack-join
 */
